OpenShot Audio Library | OpenShotAudio: juce::ReferenceCountedObject Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::ReferenceCountedObject Class Reference

`#include <juce_ReferenceCountedObject.h>`

Inheritance diagram for juce::ReferenceCountedObject:

## Public Member Functions
void | incReferenceCount () noexcept
void | decReferenceCount () noexcept
bool | decReferenceCountWithoutDeleting () noexcept
int | getReferenceCount () const noexcept

## Protected Member Functions
| ReferenceCountedObject ()=default
| ReferenceCountedObject (const ReferenceCountedObject &) noexcept
| ReferenceCountedObject (ReferenceCountedObject &&) noexcept
ReferenceCountedObject & | operator= (const ReferenceCountedObject &) noexcept
ReferenceCountedObject & | operator= (ReferenceCountedObject &&) noexcept
virtual | ~ReferenceCountedObject ()
void | resetReferenceCount () noexcept

## Detailed Description

A base class which provides methods for reference-counting.

To add reference-counting to a class, derive it from this class, and use the ReferenceCountedObjectPtr class to point to it.

e.g.

class MyClass : public ReferenceCountedObject
{
void foo();
// This is a neat way of declaring a typedef for a pointer class,
// rather than typing out the full templated name each time..
using Ptr = ReferenceCountedObjectPtr<MyClass>;
};
MyClass::Ptr p = new MyClass();
MyClass::Ptr p2 = p;
p = nullptr;
p2->foo();
juce::ReferenceCountedObjectPtr
Definition juce_ReferenceCountedObject.h:247
juce::ReferenceCountedObject::ReferenceCountedObject
ReferenceCountedObject()=default

Once a new ReferenceCountedObject has been assigned to a pointer, be careful not to delete the object manually.

This class uses an Atomic<int> value to hold the reference count, so the reference count can be updated on multiple threads. Note that whilst it's thread-safe to create and delete a ReferenceCountedObjectPtr to a ReferenceCountedObject shared between threads, it's not thread-safe to modify or swap the ReferenceCountedObject.

For a faster but non-thread-safe version, use SingleThreadedReferenceCountedObject instead.

See also
  ReferenceCountedObjectPtr, ReferenceCountedArray, SingleThreadedReferenceCountedObject

Definition at line 65 of file juce_ReferenceCountedObject.h.

## Constructor & Destructor Documentation

## ◆ ReferenceCountedObject() [1/3]

juce::ReferenceCountedObject::ReferenceCountedObject | ( |  | ) |
| protecteddefault

Creates the reference-counted object (with an initial ref count of zero).

Referenced by operator=(), operator=(), ReferenceCountedObject(), and ReferenceCountedObject().

## ◆ ReferenceCountedObject() [2/3]

juce::ReferenceCountedObject::ReferenceCountedObject | ( | const ReferenceCountedObject & |  | ) |
| inlineprotectednoexcept

Copying from another object does not affect this one's reference-count.

Definition at line 110 of file juce_ReferenceCountedObject.h.

## ◆ ReferenceCountedObject() [3/3]

juce::ReferenceCountedObject::ReferenceCountedObject | ( | ReferenceCountedObject && |  | ) |
| inlineprotectednoexcept

Copying from another object does not affect this one's reference-count.

Definition at line 112 of file juce_ReferenceCountedObject.h.

## ◆ ~ReferenceCountedObject()

virtual juce::ReferenceCountedObject::~ReferenceCountedObject | ( |  | ) |
| inlineprotectedvirtual

Destructor.

Definition at line 119 of file juce_ReferenceCountedObject.h.

## Member Function Documentation

## ◆ decReferenceCount()

void juce::ReferenceCountedObject::decReferenceCount | ( |  | ) |
| inlinenoexcept

Decreases the object's reference count. If the count gets to zero, the object will be deleted.

Definition at line 82 of file juce_ReferenceCountedObject.h.

## ◆ decReferenceCountWithoutDeleting()

bool juce::ReferenceCountedObject::decReferenceCountWithoutDeleting | ( |  | ) |
| inlinenoexcept

Decreases the object's reference count. If the count gets to zero, the object will not be deleted, but this method will return true, allowing the caller to take care of deletion.

Definition at line 94 of file juce_ReferenceCountedObject.h.

## ◆ getReferenceCount()

int juce::ReferenceCountedObject::getReferenceCount | ( |  | ) | const
| inlinenoexcept

Returns the object's current reference count.

Definition at line 101 of file juce_ReferenceCountedObject.h.

Referenced by decReferenceCount(), decReferenceCountWithoutDeleting(), and ~ReferenceCountedObject().

## ◆ incReferenceCount()

void juce::ReferenceCountedObject::incReferenceCount | ( |  | ) |
| inlinenoexcept

Increments the object's reference count.

This is done automatically by the smart pointer, but is public just in case it's needed for nefarious purposes.

Definition at line 74 of file juce_ReferenceCountedObject.h.

Referenced by juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=().

## ◆ operator=() [1/2]

ReferenceCountedObject & juce::ReferenceCountedObject::operator= | ( | const ReferenceCountedObject & |  | ) |
| inlineprotectednoexcept

Copying from another object does not affect this one's reference-count.

Definition at line 114 of file juce_ReferenceCountedObject.h.

## ◆ operator=() [2/2]

ReferenceCountedObject & juce::ReferenceCountedObject::operator= | ( | ReferenceCountedObject && |  | ) |
| inlineprotectednoexcept

Copying from another object does not affect this one's reference-count.

Definition at line 116 of file juce_ReferenceCountedObject.h.

## ◆ resetReferenceCount()

void juce::ReferenceCountedObject::resetReferenceCount | ( |  | ) |
| inlineprotectednoexcept

Resets the reference count to zero without deleting the object. You should probably never need to use this!

Definition at line 128 of file juce_ReferenceCountedObject.h.

The documentation for this class was generated from the following file:

- juce_ReferenceCountedObject.h